# -*- coding: utf-8 -*-
from __future__ import unicode_literals

#-----------------------------------------------
# fonctions utilisées directement dans tOOournoi
#-----------------------------------------------

# faire un from x import X quand tout fonctionnera nickel chrome
# import permet le reload -> débogage plus aisé si classe X modifiée

from libtooournoi import (utils, classements, duplitour, joueurs,
                          outils, parties, inscriptions)

DEBUG = True

if DEBUG:
    try:
        from imp import reload
    except ImportError:
        pass
    import pythonscript
    reload(pythonscript)
    reload(utils)
    reload(classements)
    reload(duplitour)
    reload(joueurs)
    reload(outils)
    reload(parties)
    reload(inscriptions)




#-----------------------------------------------
# UTILS
def fixePositionEtTaille(event):
    '''Fixe les dimensions des divers formulaires.'''
    O = utils.Tournoi()
    O.fixePositionEtTaille(event.Source)  

def ouvreForm(event):
    '''Routine ouvrant un formulaire.
    Nom du formulaire et nom du bouton appelant doivent être identique'''
    O = utils.Tournoi()
    O.ouvreForm(event.Source.Model.Name)

def resetteur(event):
    '''Démarrer un nouveau tournoi (séquence d'avertissement)'''
    O = outils.Outils()
    O.resetteur()

def verifiePartiesJouees(event):
    '''S'assurer que le nombre de parties à jouer ne soit pas
    inférieur au nombre de parties déjà initiées'''
    O = outils.Outils()
    O.verifiePartiesJouees(event.Source)

def refuseChaineVide(event):
    '''Oblige à nommer le tournoi'''
    O = outils.Outils()
    O.refuseChaineVide(event.Source)

def car_interdits(event):
    '''Supprime les caractères interdits en cours de frappe'''
    O = outils.Outils()
    O.car_interdits(event.Source, event.KeyChar.value)

def oblige_symbole_fixe(event):
    '''Supprime les caractères interdits en cours de frappe'''
    O = outils.Outils()
    O.oblige_symbole_fixe(event.Source)

def forms_reload(event=None):
    '''Supprime les caractères interdits en cours de frappe'''
    O = outils.Outils()
    O.forms_reload()

#-----------------------------------------------
# OPTIONS
def toggleSuspRedistr(event):
    '''Suspendre provisoirement la redistribution des tables.'''
    event.Source.Model.Parent.updateRow()

def toggleOptionSuspRedistr(event):
    '''Afficher/masquer l'option permettant de
    suspendre provisoirement la redistribution des tables.'''
    source = event.Source
    redistr = outils.Outils().infos['tablesaumerite']
    source.getByName("lblSuspRedistr").EnableVisible = redistr
    source.getByName("cocheSuspRedistr").EnableVisible = redistr

def toggleOptionTablesFixes(event):
    '''Afficher/masquer les options inutiles à l'ouverture ou ''' 
    
    return
    # provisoirement désactivé : on doit a priori pouvoir utiliser une numérotation
    # parallèle même sans redistribution des tables entre les parties.
    # À supprimer définitivement après retour des utilisateurs
    O = outils.Outils()
    O.toggleOptionTablesFixes(event.Source)

def fermerOptions(event):
    O = outils.Outils()
    source = event.Source.Model
    O.doc.CurrentController.getControl(source).setFocus()   # permet mise à jour directe
    source.Parent.updateRow()
    # ' recharge le formulaire principal, si modification du nom du tournoi
    O.ouvreForm(source.Name)
    doc = source.Parent.Parent.Parent
    O.executeDispatch(".uno:CloseDoc", frame=doc.CurrentController.Frame)

#-----------------------------------------------
# JOUEURS
def verifDoublonClassement(event):
    '''Vérifie les doublons depuis les champs Licence'''
    J = joueurs.Joueurs()
    J.verifDoublonClassement(event.Source) 

def verifDoublonJoueurBase(event):
    '''Vérifie que le joueur n'est pas déjà dans la base'''
    J = joueurs.Joueurs()
    J.verifDoublonJoueur(event.Source) 

def filtreGeneral(event):
    '''Permet de retrouver aisément un joueur.
    Le filtre fonctionne sur tous les champs.'''
    J = joueurs.Joueurs()
    J.filtreGeneral(event.Source) 

def gotoFirstBookmark(event):
    '''Affecté à l'événement 'Touche enfoncée' du champ filtre.
    Cosmétique : ramène le curseur au premier enregistrement
    (sinon se positionne sur le deuxième)'''
    J = joueurs.Joueurs()
    from com.sun.star.awt.Key import TAB
    if event.KeyCode == TAB:
        if not event.Modifiers:
            form = J.doc.DrawPage.Forms.getByName('MainForm')
            if form.Row > 1: form.previous()

def setMaj(event):
    '''Force les majuscules (Nom, Club, Fédé)'''
    source = event.Source
    texte = source.Text.strip().upper()
    source.setPropertyValue("Text", texte)

def setNomPropre(event):
    '''Force l'initiale majuscule (Prénom)'''
    J = joueurs.Joueurs()
    source = event.Source
    texte = source.Text.strip()
    source.setPropertyValue("Text", texte.title())

def ferme_F_Joueurs(event):
    '''Gestion fermeture'''
    J = joueurs.Joueurs()
    J.ferme_F_Joueurs(event.Source)

def ferme_F_Joueurs_sans_sauver(event):
    '''Gestion fermeture'''
    J = joueurs.Joueurs()
    J.ferme_F_Joueurs_sans_sauver(event.Source)

def choixFichierJoueurs(event):
    '''Associé à l'événement 'texte modifié' du contrôle FileControl,
    vérifie la validité du fichier et récupère les en-têtes de colonnes'''
    J = joueurs.Joueurs()
    J.choixFichierJoueurs(event.Source)

def optionFormatDuplitop(event):
    '''Associé à la case à cocher "Fichier joueurs DUPLITOP"'''
    J = joueurs.Joueurs()
    duplitop = event.Source.State
    dlg = event.Source.Context
    for n in range(9):
        dlg.getControl("boxEnTete%d" % (n+1)).Enable = not duplitop
        dlg.getControl("lbl%d" % (n+1)).Enable = not duplitop
        if duplitop: dlg.getControl("boxEnTete%d" % (n+1)).selectItemPos(n, True)
    dlg.getControl("Label2").Enable = not duplitop
    # ' il faut ici relancer la procédure choixFichierJoueurs
    J.choixFichierJoueurs(event.Source)

def verifDoublonListBox(event):
    '''associé à l'événement 'statut modifié' des listbox inscriptions,
    avertit si un même en-tête est saisi plus d'une fois'''
    J = joueurs.Joueurs()
    source = event.Source
    pos = int(source.Model.Name[-1])-1
    itemPos = int(source.SelectedItemPos)
    if utils.colonnesPos[pos] == itemPos or itemPos == -1: return  # pas de changement
    if itemPos in utils.colonnesPos:
        J.msgbox("Attention : cet en-tête est déjà attribué.\t", "Avertissement", 'warn')
        source.selectItemPos(itemPos, False)    # conversion implicite de itemPos
        utils.colonnesPos[pos] = -1
        return
    utils.colonnesPos[pos] = itemPos

def controleImportJoueurs(event):
    try:
        from http.client import HTTPConnection
        from urllib.parse import urlparse
    except ImportError:
        from httplib import HTTPConnection
        from urlparse import urlparse
    from socket import error as socketerror

    J = joueurs.Joueurs()
    # récupère l'url par défaut si pointe effectivement vers un fichier
    cles = J.clesOptions()
    defaultURL = cles.PlayersUpdateUrl
    # on vérifie que la source existe
    bdp = J.barreDeProgression("Tentative de connexion à %s...\t" % defaultURL, 3)
    bdp.start()
    bdp.setValue(1)
    try:
        urlparsed = urlparse(defaultURL)
        conn = HTTPConnection(urlparsed.netloc, timeout=1)
        conn.request("HEAD", urlparsed.path)
        resp = conn.getresponse()
        status = resp.status
        bdp.setValue(2)
    except socketerror as e:
        status = 404
        bdp.end()
    if status < 400:
        J.importJoueurs(bdp, defaultURL)
    else:
        J.importJoueurs(bdp)

#-----------------------------------------------
# INSCRIPTIONS
def ouvrirInscrits(event):
    I = inscriptions.Inscriptions()
    I.ouvrirInscrits(event.Source)

def ouvertureInscription(event):
    '''Routine exécutée au chargement du formulaire Inscriptions'''
    I = inscriptions.Inscriptions()
    I.ouvertureInscription(event.Source)

def fermetureInscription(event):
    '''Routine exécutée au chargement du formulaire Inscriptions'''
    I = inscriptions.Inscriptions()
    I.callXray(I.doc)

def inscrireJoueur(event):
    '''Inscrit le joueur sélectionné'''
    I = inscriptions.Inscriptions()
    I.inscrireJoueur(event.Source)

def filtreJoueurs(event):
    '''Filtre les joueurs suivant la saisie (formulaire inscriptions solo)'''
    I = inscriptions.Inscriptions()
    I.filtreJoueurs(event.Source)

def navigJoueurs(event):
    '''permet de naviguer dans la base joueur à partir du contrôle de saisie du nom à inscrire'''
    key = event.KeyCode
    form = event.Source.Model.Parent
    form_joueurs = form.Parent.getByName("joueurs")
    if not form_joueurs.RowCount:
        form_joueurs = form.Parent.getByName("inscrits")
    if not key in (1024,1025): return
    if key == 1024:  #' flèche bas
        if form_joueurs.isLast():
            form_joueurs.first()
        else: form_joueurs.next()
    elif key == 1025:  #' flèche haut
        if form_joueurs.isFirst():
            form_joueurs.last()
        else: form_joueurs.previous()       

def fermerInscriptions(event): 
    '''Sauvegarde et ferme le formulaire Inscriptions'''
    I = inscriptions.Inscriptions()
    doc = event.Source.Model.Parent.Parent.Parent
    I.executeDispatch(".uno:CloseDoc", frame=doc.CurrentController.Frame)

def verifDoublonLicence(event):
    '''Vérifie les doublons depuis les champs Licence'''
    I = inscriptions.Inscriptions()
    I.verifDoublonLicence(event.Source) 

def verifDoublonJoueur(event):
    '''Vérifie les doublons depuis les champs Joueur'''
    I = inscriptions.Inscriptions()
    I.verifDoublonJoueur(event.Source) 

def verifDoublonTable(event):
    '''Vérifie les doublons depuis le champ Table'''
    I = inscriptions.Inscriptions()
    I.verifDoublonTable(event.Source) 

def reloadMenu(event):
    '''Routine exécutée au chargement du formulaire Inscriptions'''
    I = inscriptions.Inscriptions()
    I.reloadMenu()

def reclasserPaires(event):
    '''Classe les paires alphabétiquement'''
    I = inscriptions.Inscriptions()
    I.reclasserPaires(event.Source)

def navigF_Inscription(event):
    '''Rend la navigation plus confortable en sautant les colonnes inutiles'''
    I = inscriptions.Inscriptions()
    if I.infos['paires']: return
    controle = I.doc.CurrentController.getControl(event.Source.Model)
    colonne = controle.getCurrentColumnPosition()    # colonne d'arrivée
    contexte = event.Modifiers, event.KeyCode, colonne
    # Modifiers : 0=aucun, 1=SHIFT - KeyCode : 1280=RETURN, 1282=TAB, 1026=LEFT
    cas = {(0,1280,2):2, (0,1282,2):2, (0,1026,3):-2, (1,1282,3):-2}
    if contexte in cas:
        controle.setCurrentColumnPosition(colonne + cas[contexte])

def ouvreJoueur(event):
    '''Ouvre le formulaire d'édition de la base Joueurs'''
    I = inscriptions.Inscriptions()
    I.ouvreJoueur()

def autoriseNouveauxJoueurs(event):
    '''Débloque l'inscription directe'''
    I = inscriptions.Inscriptions()
    I.autoriseNouveauxJoueurs(event.Source)

def controleImportInscrits(event):
    ''' Contrôle l'ouverture du dialogue d'importation'''
    I = inscriptions.Inscriptions()
    # appel depuis le classeur des inscrits, pour correction a posteriori
    if event.Source.Model.Name == 'corrigerinscrits':
        I.importinscrits2(event.Source)
    else:
        if I.infos['derpartie']:
            I.msgbox("\nUne première partie a déjà été initiée.\t\n"
                     "Cette opération n'est plus possible.\n\n", "Avertissement", 'warn')
            return
        I.importinscrits(event.Source)
    forms_reload()

def choixFichierInscrits(event):
    '''
    Associé à l'événement 'texte modifié' du contrôle FileControl,
    vérifie la validité du fichier et récupère les en-têtes de colonnes
    '''
    I = inscriptions.Inscriptions()
    utils.colonnesPos = [-1]*6
    I.choixFichierInscrits(event.Source)

def verifListBoxInscrits(event):
    '''associé à l'événement 'statut modifié' des listbox inscriptions,
    avertit si un même en-tête est saisi plus d'une fois'''
    I = inscriptions.Inscriptions()
    source = event.Source
    pos = int(source.Model.Name[-1])-1
    itemPos = int(source.SelectedItemPos)
    if utils.colonnesPos[pos] == itemPos or itemPos == -1: return  # pas de changement
    if itemPos in utils.colonnesPos:
        I.msgbox("Attention : cet en-tête est déjà attribué.\t", "Avertissement", 'warn')
        source.selectItemPos(itemPos, False)    # conversion implicite de itemPos
        utils.colonnesPos[pos] = -1
        return
    utils.colonnesPos[pos] = itemPos

def copyTextToClipBoard(event):
    '''Copie le log d'import des inscrits dans le presse-papier'''
    I = inscriptions.Inscriptions()
    texteCtrl = event.Source.Context.getControl("bTexte")
    I.TextToClipboard( texteCtrl.Text )
    sel = texteCtrl.Selection
    sel.Min = 0
    sel.Max = len(texteCtrl.Text)
    texteCtrl.setSelection(sel)
    # I.msgbox("Le texte a bien été copié\ndans le presse-papiers.")

def controleTabulateur(event):
    '''Contrôle l'accès au tabulateur'''
    I = inscriptions.Inscriptions()
    source = event.Source
    # si aucun inscrit...
    if not source.Model.Parent.RowCount:
        I.msgbox("Aucun inscrit !", "Erreur", 'warn')
        return
    # ... si une partie a été initiée...
    elif I.infos['derpartie']:
        I.msgbox ("\nUne première partie a déjà été initiée et\n"
                  "cette opération n'a donc plus lieu d'être.\t\n\n"
                  "Au besoin, éditez manuellement la table\n"
                  "correspondante.\n\n", "Avertissement", 'warn')
        return
    # ... sinon ouvre le dialogue
    dlg = I.createTooournoiDialog('dialogue1')
    height = dlg.Model.Height
    # désactive "clubs non contigus" pour compétitions par paires
    if I.infos['paires']:
        dlg.Model.getByName('clubsnoncontigus').EnableVisible = False
        dlg.Model.getByName('clubsnoncontigus2').EnableVisible = False
        height -= dlg.Model.getByName('clubsnoncontigus').Height
    # désactive choix fixe si option "tables parallèles"
    if I.infos['tablesparalleles']:
        dlg.Model.Step = 2
        height -= dlg.Model.getByName('fixe0').Height
    dlg.Model.Height = height
    if source.Model.Parent.Name == "inscrits":
        inscrits = source.Model.Parent
        if inscrits.IsModified: inscrits.updateRow()
        dlg.execute()
        inscrits.reload()
    else:
        dlg.execute()

def toggleTablesSpecifiques(event):
    '''Commute le contrôle "tables spécifiques" suivant l'option cochée'''
    I = inscriptions.Inscriptions()
    source = event.Source
    source.Context.getControl('fixe4').Enable = source.Context.getControl('fixe3').State

def tabulateur(event):
    '''Lance l'attribution automatique des numéros de table'''
    I = inscriptions.Inscriptions()
    I.tabulateur(event.Source)

def controleSaisieTablesFixes(event):
    I = inscriptions.Inscriptions()
    I.controleSaisieTablesFixes(event.Source)

def ouvrirPermutateur(event):
    '''Refuse l'accès à permutateur si moins de deux inscrits'''
    I = inscriptions.Inscriptions()
    if event.Source.Model.Parent.RowCount < 2:
        I.msgbox("Pas même deux inscrits !\t", "Erreur", 'warn')
        return
    # ... sinon appelle la routine correspondante
    I.ouvreForm(event.Source.Model.Name)

def ouverturePermutateur(event):
    '''Permet de garder l'équilibre entre les deux tableaux'''
    I = inscriptions.Inscriptions()
    # il y a deux formulaires parallèles, avec chacun un contrôle de table
    for i in (0,1):  
        tc = event.Source.Parent.getByIndex(i).getByName("tblPermut")
        tc.getByName('ColClub').Hidden = I.infos['paires']
        tc.getByName('ColJoueur').Hidden = I.infos['paires']
        tc.getByName('ColPaires').Hidden = not I.infos['paires']
        tc.RowHeight = I.HLIGNE
        tc.Parent.moveToBookmark(i+1)

def permutateur(event):
    '''Permute les tables de deux joueurs en conservant leurs points'''
    I = inscriptions.Inscriptions()
    I.permutateur()

def exportDuplitop(event):
    '''Exporte la liste des joueurs au format DUPLITOP'''
    I = inscriptions.Inscriptions()
    I.exportDuplitop(event.Source)

def exportInscritsCSV(event=None):
    '''Exporte la liste des joueurs au format CSV'''
    I = inscriptions.Inscriptions()
    I.exportInscritsCSV(event.Source)
    I.msgbox("Export terminé.")

#-----------------------------------------------
# PARTIES
def annulerDerPartie(event=None):
    P = parties.Parties()
    P.annulerDerPartie()

def preambuleInitierPartie(event):
    P = parties.Parties()
    P.preambuleInitierPartie(event.Source)

def choixFichiersResultats(event):
    '''Routine affectée au bouton "Parcourir..."
    du dialogue d'import des résultats'''
    P = parties.Parties()
    dlg = event.Source.Context
    filenames = P.filePicker(filters=(("Résultats Duplitop", "*table*.txt"),
                                      ("Tous les fichiers (*.*)", "*.*")),
                             multi=True)
    if filenames:
        P.fichiersresultats[:] = filenames
        dlg.getControl("txtFileControl").setText(P.convertFromUrl(filenames[0]))
        dlg.getControl("BoutonOK").setFocus()

def importerResultats(event):
    P = parties.Parties()
    P.fichiersresultats[:] = []
    P.importerResultats(event.Source)

def importerResultatsDuClasseur(event):
    P = parties.Parties()
    P.fichiersresultats[:] = []
    P.importerResultatsDuClasseur(event.Source)

def preambuleSaisiePoints(event):
    '''Avertissement avant saisie manuelle des points'''
    P = parties.Parties()
    if not P.infos['derpartie']:
        P.msgbox("Aucune partie n'a encore été initiée.\t", "Erreur", 'warn')
        return
    P.ouvreForm(event.Source.Model.Name)

def choixPartieSaisiePoints(event):
    P = parties.Parties()
    P.choixPartieSaisiePoints(event.Source)

def curseurGrillePoints(event):
    '''Positionne le curseur au chargement'''
    P = parties.Parties()
    col = event.Source.getByName("Grid_Saisie_Points")
    P.doc.CurrentController.getControl(col).setCurrentColumnPosition(1)

def recalculsSaisiePoints(event):
    '''Recalculs après saises'''
    P = parties.Parties()
    P.recalculsSaisiePoints(event.Source)

def navigationSaisiePoints(event):
    '''Rend la navigation plus confortable en sautant les colonnes inutiles'''
    P = parties.Parties()
    if event.KeyCode != 1282 and event.KeyCode != 1280: return
    form = P.doc.DrawPage.Forms.getByName('MainForm')
    col = event.Source.Model
    gc = P.doc.CurrentController.getControl(col)
    if event.Modifiers == 0:
        if form.IsModified: form.updateRow()
        if not form.isLast(): form.next()
        gc.setCurrentColumnPosition(1)
    if event.Modifiers == 1 and event.KeyCode == 1282:
        if form.IsModified: form.updateRow()
        if not form.isFirst(): form.previous()
        gc.setCurrentColumnPosition(1)

#-----------------------------------------------
# CLASSEMENTS
def ouvrirClasseur(ev=None):
    C = classements.Classements()
    source = ev.Source.Model
    C.ouvrirClasseur(source.Name, source.Parent)

def toggleProtection(ev=None):
    C = classements.Classements()
    lbl = ev.Source.Model.Label
    func = {"déprotéger les feuilles": (C.unprotectSheets, lbl[2:]),
            "protéger les feuilles":  (C.protectSheets, 'dé'+lbl)}
    func[lbl][0]()
    ev.Source.Model.Label = func[lbl][1]

def rafraichirClassements(ev=None):
    classements.rafraichirClassements()

def categLLN(ev=None):
    C = classements.Classements()
    if not ev.AbsoluteName == '$CATÉGORIES.$C$1':
        return
    C.unprotectSheets()
    C.categLLN()
    C.protectSheets()

def exportResultatsFinaux(ev=None):
    C = outils.Outils()
    if C.exportCSV():
        C.msgbox("Export terminé.")

def exportClassement(ev=None):
    '''
    le nom du bouton appelant doit être composé sur le modèle "<type export><varchar><_><type feuille>"
    <type export> : "CSV" ou "PDF"
    <varia> : n'importe quels caractères autres que '_'
    <_> : un seul caractère '_'
    <type feuille> : "1" pour classement complet, 2 pour classement par catégorie
    Ex : "CSV1_1" ou "PDF-test_2"
    '''
    C = classements.Classements()
    nom = ev.Source.Model.Name
    model = nom.split('_')[1]
    if nom.startswith('CSV'):
        C.exportCSV(model)
    else:
        C.exportPDF(model)
    C.msgbox("Export terminé.")

def changerPartie(ev=None):
    classements.changerPartie()

#-----------------------------------------------
# DUPLITOUR
def ouvrirStatsDuplitour(event=None):
    D = duplitour.Duplitour()
    D.ouvrirClasseur()

def importPartie(event=None):
    duplitour.Duplitour().importPartie()

def statsParPartie(event=None):
    D = duplitour.Duplitour()
    f = D.doc.CurrentController.ActiveSheet
    form = f.DrawPage.Forms.getByName("Formulaire")
    source = form.getByName("zlPartie")
    D.statsParPartie(source.SelectedItems[0])
    source.commit()
    form.updateRow()

#-----------------------------------------------
# OUTILS
def prepareImportTournoi(event=None):
    O = outils.Outils()
    O.prepareImportTournoi()
    
def importTournoi(event=None):
    O = outils.Outils()
    O.importerTournoi(event.Source)
    
def defragmenter(event=None):
    O = outils.Outils()
    O.defragmenter()

def exportODS(event=None):
    '''Export des données dans tableur'''
    O = outils.Outils()
    if not O.infos['derpartie']:
        O.msgbox("Aucune partie n'a encore été initiée.\t\n", "Erreur", 'warn')
    else: O.exportODS()

def mailtofede(event):
    '''Prépare l'envoi des résulats par mail'''
    O = outils.Outils()
    O.mailtofede()

def archivesOnClick(event): 
    from com.sun.star.awt.KeyModifier import MOD1
    O = outils.Outils()
    if event.ClickCount == 2:
        # ' double-clic -> charger
        if not event.Modifiers:
            charger_archives(event)
        # ' Ctrl+double-clic -> supprimer
        elif event.Modifiers == MOD1:
            supprimer_archives(event)

def charger_archives(event):
    O = outils.Outils()
    O.charger_archives(event.Source)
    forms_reload()

def supprimer_archives(event):
    O = outils.Outils()
    O.supprimer_archives(event.Source)
    forms_reload()

def changeOnglet(event=None, nom=None):
    '''Routine changement d'onglet'''
    O = outils.Outils()
    nom = nom or event.Source.Model.Name
    O.changeOnglet(nom)

def changeOnglet_Alt_A():
    changeOnglet(nom="Menu_Principal")

def changeOnglet_Alt_I():
    changeOnglet(nom="Menu_Inscriptions")

def changeOnglet_Alt_P():
    changeOnglet(nom="Menu_Parties")

def changeOnglet_Alt_O():
    changeOnglet(nom="Menu_Outils")
